
#include "osnovnoOkno.h"
#include "ui_osnovnoOkno.h"
#include "sahovnicaOkno.h"
#include "ui_sahovnicaOkno.h"
#include "../dgtnix.h"
#include <errno.h>
#include <QMessageBox>
#include <QDesktopWidget>
#include <QStyle>

// Globalne spremenljivke
QLineEdit *naprava;
sahovnicaOkno *oknoDGT;

// Zagon aplikacije
osnovnoOkno::osnovnoOkno(QWidget *parent) : QMainWindow(parent), ui(new Ui::osnovnoOkno)
{
    ui->setupUi(this);
    ui->btnPovezava->setText("Povezi"); // nastavljen gumb pri povezavi na "Povezi"
    ui->statusBar->showMessage("Pripravljen @ Cakam na povezavo.."); // prikaz sporocila v status baru
    ui->btnPrikazi->setEnabled(false);
    ui->btnPrikazi->setVisible(false);
}

// Destruktor
osnovnoOkno::~osnovnoOkno() { delete ui; }

// Klik na gumb pri Povezavi
void osnovnoOkno::on_btnPovezava_clicked()
{
    if (ui->btnPovezava->text().toLatin1() == "Povezi") // nastavljena vrednost "Povezi"
    {
        if (ui->lePovezava->text().toLatin1() == "") // preverimo ali je vnos ali ne
            QMessageBox::warning(this, tr("Napaka"), tr("Manjkajo vrata povezave.\n\nPrimer vnosa: /dev/ttyUSB0"));
        else
        {
            naprava = new QLineEdit;
            naprava->setText(ui->lePovezava->text()); // shranimo v globalno spremenljivko

            ui->statusBar->showMessage("Ponovno povezujem.."); // prikaz trenutnega dogajanja v status baru

            oknoDGT = new sahovnicaOkno;
            oknoDGT->setGeometry(QStyle::alignedRect(Qt::LeftToRight, Qt::AlignCenter, oknoDGT->size(), qApp->desktop()->availableGeometry()));

            oknoDGT->vzpostaviPovezavo(naprava->text().toLatin1());

            if (oknoDGT->dobiUspesnoPovezavo() < 0) // prislo je do napake
            {
                if (oknoDGT->dobiUspesnoPovezavo() == -1)
                {
                    QString text = "Prislo je do napake.\n\nIzpis napake:\nUnable to open device " + naprava->text() + ": " + strerror(errno);
                    QMessageBox::warning(this, tr("Napaka"), tr(text.toLatin1()));
                    ui->statusBar->showMessage("Prislo je do napake. @ Cakam na ponovno povezavo..");
                    ui->btnPovezava->setText("Poskusi znova");
                }
                else if (oknoDGT->dobiUspesnoPovezavo() == -2)
                {
                    QString text = "Prislo je do napake.\n\nIzpis napake:\nUnrecognized device (not responding to DGT_SEND_BRD) : " + naprava->text();
                    QMessageBox::warning(this, tr("Napaka"), tr(text.toLatin1()));
                    ui->statusBar->showMessage("Prislo je do napake. @ Cakam na ponovno povezavo..");
                    ui->btnPovezava->setText("Poskusi znova");
                }
            }
            else
            {
                ui->statusBar->showMessage("Povezava je vzpostavljena..");
                oknoDGT->setOkno(this->ui);
                oknoDGT->show();
                ui->btnPovezava->setText("Koncaj program");
            }
        }
    }
    else if (ui->btnPovezava->text().toLatin1() == "Poskusi znova") // nastavljena vrednost "Poskusi znova"
    {
        if (ui->lePovezava->text().toLatin1() == "") // preverimo ali je vnos ali ne
            QMessageBox::warning(this, tr("Napaka"), tr("Manjkajo vrata povezave.\n\nPrimer vnosa: /dev/ttyUSB0"));
        else
        {
            naprava = new QLineEdit;
            naprava->setText(ui->lePovezava->text()); // shranimo v globalno spremenljivko

            ui->statusBar->showMessage("Ponovno povezujem.."); // prikaz trenutnega dogajanja v status baru

            oknoDGT = new sahovnicaOkno;
            oknoDGT->setGeometry(QStyle::alignedRect(Qt::LeftToRight, Qt::AlignCenter, oknoDGT->size(), qApp->desktop()->availableGeometry()));

            oknoDGT->vzpostaviPovezavo(naprava->text().toLatin1());

            if (oknoDGT->dobiUspesnoPovezavo() < 0) // prislo je do napake
            {
                if (oknoDGT->dobiUspesnoPovezavo() == -1)
                {
                    QString text = "Prislo je do napake.\n\nIzpis napake:\nUnable to open device " + naprava->text() + ": " + strerror(errno);
                    QMessageBox::warning(this, tr("Napaka"), tr(text.toLatin1()));
                    ui->statusBar->showMessage("Prislo je do napake. @ Cakam na ponovno povezavo..");
                    ui->btnPovezava->setText("Poskusi znova");
                }
                else if (oknoDGT->dobiUspesnoPovezavo() == -2)
                {
                    QString text = "Prislo je do napake.\n\nIzpis napake:\nUnrecognized device (not responding to DGT_SEND_BRD) : " + naprava->text();
                    QMessageBox::warning(this, tr("Napaka"), tr(text.toLatin1()));
                    ui->statusBar->showMessage("Prislo je do napake. @ Cakam na ponovno povezavo..");
                    ui->btnPovezava->setText("Poskusi znova");
                }
            }
            else
            {
                ui->statusBar->showMessage("Povezava je vzpostavljena..");
                oknoDGT->setOkno(this->ui);
                oknoDGT->show();
                ui->btnPovezava->setText("Koncaj program");
            }
        }
    }
    else if (ui->btnPovezava->text().toLatin1() == "Koncaj program") // nastavljena vrednost "Prekini"
    {
        ui->statusBar->showMessage("Prekinjam..");
        ui->btnPovezava->setText("Povezi");
        ui->statusBar->showMessage("Povezava je bila prekinjena..");
        oknoDGT->close();
        this->close();
    }
}

void osnovnoOkno::on_btnPrikazi_clicked()
{
    oknoDGT->show();
    ui->btnPrikazi->setEnabled(false);
    ui->btnPrikazi->setVisible(false);
}
